## sdcc 2.5.0

=== Makefile ===
#
#
#

SHELL		= /bin/sh

PRJDIR		= .

include $(PRJDIR)/Makefile.common

SDCC_MISC	= debugger/mcs51 sim/ucsim
SDCC_LIBS	= support/cpp2 support/makebin
SDCC_DOC        = doc

# Parts that are not normally compiled but need to be cleaned
SDCC_EXTRA      = support/regression

SDCC_ASLINK	= as/mcs51 as link as/hc08
SDCC_PACKIHX	= packihx
SDCC_LIBRARIAN	= support/librarian

TARGETS         = sdcc-libs sdcc-cc sdcc-aslink sdcc-doc

PKGS		= $(SDCC_LIBS) src $(SDCC_ASLINK) $(SDCC_DOC)

ifneq ($(OPT_ENABLE_UCSIM), no)
TARGETS         += sdcc-misc 
PKGS            += $(SDCC_MISC)
endif

ifneq ($(OPT_ENABLE_DEVICE_LIB_BUILD), no)
TARGETS         += sdcc-device
PKGS            += device/include device/lib
endif

ifneq ($(OPT_ENABLE_PACKIHX), no)
TARGETS         += sdcc-packihx
PKGS            += $(SDCC_PACKIHX)
endif

TARGETS         += sdcc-librarian
PKGS            += $(SDCC_LIBRARIAN)

PKGS_TINI	= $(SDCC_LIBS) $(SDCC_ASLINK) \
		  src device/include $(SDCC_PACKIHX) $(SDCC_LIBRARIAN)
PORTS		= $(shell cat ports.build)
ALLPORTS	= $(shell cat ports.all)

# Compiling entire program or any subproject
# ------------------------------------------
all: checkconf sdcc

tini: checkconf sdcc-tini

sdcc-libs:
	for lib in $(SDCC_LIBS); do $(MAKE) -C $$lib; done

sdcc-cc: sdcc-libs
	$(MAKE) -C src

sdcc-aslink:
	for as in $(SDCC_ASLINK); do $(MAKE) -C $$as; done

sdcc-misc:
	for misc in $(SDCC_MISC); do $(MAKE) -C $$misc; done

sdcc-packihx:
	$(MAKE) -C $(SDCC_PACKIHX)

sdcc-librarian:
	$(MAKE) -C $(SDCC_LIBRARIAN)

sdcc-device: sdcc-cc sdcc-aslink
	$(MAKE) -C device/include
	$(MAKE) -C device/lib

sdcc-device-tini:
	$(MAKE) -C device/include
	$(MAKE) -C device/lib modelDS390

# Empty for now, as doc depends on latex and latex2html
sdcc-doc:

sdcc: $(TARGETS)

sdcc-tini: sdcc-cc sdcc-aslink sdcc-device-tini sdcc-packihx sdcc-librarian
	$(MAKE) -f main.mk all

# Some interesting sub rules
sdcc-bin: sdcc-cc sdcc-aslink sdcc-misc

sdcc-base: sdcc-cc sdcc-aslink

# Compiling and installing everything and runing test
# ---------------------------------------------------
install:
	$(MAKE) -f main.mk install
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg install ;\
	done

install-tini:
	$(MAKE) -f main.mk install
	@for pkg in $(PKGS_TINI); do\
	  $(MAKE) -C $$pkg install ;\
	done
	$(MAKE) -C device/lib installDS390



# Deleting all the installed files
# --------------------------------
uninstall:
	$(MAKE) -f main.mk uninstall
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg uninstall ;\
	done


# Deleting all files created by building the program
# --------------------------------------------------
clean:
	@echo "+ Cleaning root of the project..."
	$(MAKE) -f clean.mk clean
	@echo "+ Cleaning packages in their directories..."
	for pkg in $(PKGS); do\
	  $(MAKE) PORTS="$(PORTS)" EXEEXT=$(EXEEXT) -C $$pkg -f clean.mk clean ;\
	done

# Deleting all files created by configuring or building the program
# -----------------------------------------------------------------
distclean:
	@echo "+ DistCleaning root of the project..."
	$(MAKE) -f clean.mk distclean
	@echo "+ DistCleaning packages using clean.mk..."
	for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg PORTS="$(PORTS)" EXEEXT=$(EXEEXT) -f clean.mk distclean ;\
	done
	for pkg in $(SDCC_EXTRA); do \
	  $(MAKE) -C $$pkg clean; \
	done

# Like clean but some files may still exist
# -----------------------------------------
mostlyclean: clean
	$(MAKE) -f clean.mk mostlyclean
	for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk PORTS="$(PORTS)" EXEEXT=$(EXEEXT) mostlyclean ;\
	done


# Deleting everything that can reconstructed by this Makefile. It deletes
# everything deleted by distclean plus files created by bison, stc.
# -----------------------------------------------------------------------
realclean: distclean
	$(MAKE) -f clean.mk realclean
	for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk PORTS="$(PORTS)" EXEEXT=$(EXEEXT) realclean ;\
	done


# Creating distribution
# ---------------------
dist: distclean
	@if [ -f devel ]; then\
	  rm -f devel; mkdist sdcc; touch devel;\
	else\
	  mkdist sdcc;\
	fi


# Performing self-test
# --------------------
check:


# Performing installation test
# ----------------------------
installcheck:


# Creating dependencies
# ---------------------
dep:
	$(MAKE) -f main.mk dep
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg dep ;\
	done


# My rules
# --------
newer: distclean
	@if [ -f start ]; then \
	  tar cvf - \
	    `find . -newer start -type f -print` |\
	  gzip -9c >`date '+%m%d%H%M'`.tgz; \
	else \
	  echo "start file not found.\n"; \
	  exit 1; \
	fi

putcopyright:
	'put(c)' -s $(STARTYEAR) *.cc *.h *.y *.l


# Remaking configuration
# ----------------------
configure: configure.in
	$(SHELL) $(AUTOCONF)

main.mk: $(srcdir)/main_in.mk $(srcdir)/configure.in config.status
	$(SHELL) ./config.status

Makefiles: makefiles

makefiles: config.status

config.status: configure
	$(SHELL) ./config.status --recheck

makefiles:
	$(SHELL) ./config.status

freshconf: main.mk

checkconf:
	@if [ -f devel ]; then\
	  $(MAKE) freshconf;\
	fi

# End of Makefile

=== as/Makefile ===
PRJDIR = ..
BUILDDIR=../../bin
include $(PRJDIR)/Makefile.common

PORTS = z80 gbz80 hc08
DOCS = README abstra.doc appendk.txt asmlnk.doc asxhtm.html format.txt

all:
	$(MAKE) -C z80 _as-z80 _as-gbz80 E=$(E) BUILDDIR=$(BUILDDIR)
	$(MAKE) -C hc08 all E=$(E) BUILDDIR=$(BUILDDIR)

install: all install-doc
	$(INSTALL) $(PRJDIR)/bin/as-z80$(EXEEXT) `echo $(DESTDIR)$(bindir)/as-z80$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/as-z80$(EXEEXT)|sed '$(transform)'`
	$(INSTALL) $(PRJDIR)/bin/as-gbz80$(EXEEXT) `echo $(DESTDIR)$(bindir)/as-gbz80$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/as-gbz80$(EXEEXT)|sed '$(transform)'`
	$(INSTALL) $(PRJDIR)/bin/as-hc08$(EXEEXT) `echo $(DESTDIR)$(bindir)/as-hc08$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/as-hc08$(EXEEXT)|sed '$(transform)'`

install-doc:
	$(INSTALL) -d $(DESTDIR)$(docdir)/aslink
	cp -f `find doc -maxdepth 1 -type f` $(DESTDIR)$(docdir)/aslink

uninstall:
	cd $(DESTDIR)$(bindir); rm -f as-z80$(EXEEXT) as-gbz80$(EXEEXT) as-hc08$(EXEEXT)

include clean.mk

=== doc/Makefile ===
include ../Makefile.common

MANUAL = sdccman
TSS = test_suite_spec
CDB = cdbfileformat

all: $(MANUAL).pdf $(MANUAL).html/index.html $(MANUAL).txt \
	$(TSS).pdf $(TSS).html/index.html $(TSS).txt \
	$(CDB).pdf $(CDB).html/index.html $(CDB).txt

install:
	$(INSTALL) -d $(DESTDIR)$(docdir)
	cp -rf *.txt z80 avr $(DESTDIR)$(docdir)
	if [ -f $(MANUAL).html/index.html ]; then cp -rf $(MANUAL).html $(DESTDIR)$(docdir); fi
	if [ -f $(TSS).html/index.html    ]; then cp -rf $(TSS).html    $(DESTDIR)$(docdir); fi
	if [ -f $(CDB).html/index.html    ]; then cp -rf $(CDB).html    $(DESTDIR)$(docdir); fi
	if [ -f $(MANUAL).pdf             ]; then cp -rf $(MANUAL).pdf  $(DESTDIR)$(docdir); fi
	if [ -f $(TSS).pdf                ]; then cp -rf $(TSS).pdf     $(DESTDIR)$(docdir); fi
	if [ -f $(CDB).pdf                ]; then cp -rf $(CDB).pdf     $(DESTDIR)$(docdir); fi
	rm -rf `find $(DESTDIR)$(docdir) -name CVS -type d`
	rm -f $(DESTDIR)$(docdir)/*/WARNINGS $(DESTDIR)$(docdir)/*/*.pl $(DESTDIR)$(docdir)/*/images.*

uninstall:
	rm -rf $(DESTDIR)$(docdir)

$(MANUAL).html/index.html: $(MANUAL).tex $(MANUAL).ind ;#$(MANUAL).glo
	mkdir -p `dirname $@`
	# fixes latex2html problems with two consecutive dashes for long-options: --stack-auto
	# fixes latex2html problems with \tabularnewline
	mv $< `basename $< .tex`.orig.tex
	sed 's,-\\/-,-\\/-\\/-,g' < `basename $< .tex`.orig.tex | \
	sed 's,\\tabularnewline$$,\\\\,g' > $<
	-latex2html -split 5 -show_section_numbers -local_icons -info "" -dir $(MANUAL).html $(MANUAL)
	mv `basename $< .tex`.orig.tex $<

$(TSS).html/index.html: $(TSS).tex
	mkdir -p `dirname $@`
	# fixes latex2html problems with two consecutive dashes for long-options: --stack-auto
	# fixes latex2html problems with \tabularnewline
	mv $< `basename $< .tex`.orig.tex
	sed 's,-\\/-,-\\/-\\/-,g' < `basename $< .tex`.orig.tex | \
	sed 's,\\tabularnewline$$,\\\\,g' > $<
	-latex2html -split 0 -local_icons -info "" -dir $(TSS).html $(TSS)
	mv `basename $< .tex`.orig.tex $<

$(CDB).html/index.html: $(CDB).tex
	mkdir -p `dirname $@`
	# fixes latex2html problems with two consecutive dashes for long-options: --stack-auto
	# fixes latex2html problems with \tabularnewline
	mv $< `basename $< .tex`.orig.tex
	sed 's,-\\/-,-\\/-\\/-,g' < `basename $< .tex`.orig.tex | \
	sed 's,\\tabularnewline$$,\\\\,g' > $<
	-latex2html -split 0 -show_section_numbers -local_icons -info "" -dir $(CDB).html $(CDB)
	mv `basename $< .tex`.orig.tex $<

%.txt: %.lyx
	lyx -e text $<

%.pdf: %.tex %.dvi %.ind
	dvipdf $*
# pdflatex creates documents for acrobat reader >= 5.0	
#	which pdflatex > /dev/null && pdflatex $* || dvipdf $*

%.ps:  %.pdf
	dvips $*

%.dvi: %.tex
	latex $<

%.tex: %.lyx
	lyx -e latex $<

%.ind: %.dvi
	latex $*
	-makeindex $*
#	-makeindex -s l2hidx.ist $*
	latex $*
	latex $*

%.glo: %.dvi
	# the glossary, not implemented yet
	# makeindex -s l2hglo.ist -o $@ $<

archive: all
	rm -rf sdcc-doc sdcc-doc.tar.bz2
	mkdir sdcc-doc
	rsync -rCt avr z80 *.pdf *.txt sdcc-doc

	for doc in $(MANUAL) $(TSS) $(CDB); do \
	  rsync -Rt $$doc.html/*.html $$doc.html/*.png $$doc.html/*.css sdcc-doc/; \
	done

	mkdir sdcc-doc/as
	rsync -rCt ../as/doc/* sdcc-doc/as/

	mkdir sdcc-doc/ucsim
	cd ../sim/ucsim/doc; rsync *.html *.jpg *.gif *.fig ../../../doc/sdcc-doc/ucsim/

	tar -c sdcc-doc | bzip2 -9 > sdcc-doc.tar.bz2

include clean.mk

=== link/Makefile ===
PRJDIR = ..

include $(PRJDIR)/Makefile.common

PORTS = z80 gbz80

all: 
	$(MAKE) -C z80 _link-z80 _link-gbz80 E=$(E) BUILDDIR=../../bin/

install: all
	$(INSTALL) $(PRJDIR)/bin/link-z80$(EXEEXT) `echo $(DESTDIR)$(bindir)/link-z80$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/link-z80$(EXEEXT)|sed '$(transform)'`
	$(INSTALL) $(PRJDIR)/bin/link-gbz80$(EXEEXT) `echo $(DESTDIR)$(bindir)/link-gbz80$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/link-gbz80$(EXEEXT)|sed '$(transform)'`

uninstall:
	cd $(DESTDIR)$(bindir); rm -f link-z80$(EXEEXT) link-gbz80$(EXEEXT)

include clean.mk

=== as/xa51/Makefile ===
CC = gcc
CFLAGS = -ggdb -Wall
YACC = bison -y -d
LEX = flex -i
LEXLIB = 

all: xa_rasm xa_link

OBJECTS = xa_main.o xa_rasm.tab.o xa_rasm.lex.o  

xa_rasm: $(OBJECTS)
	$(CC) -o xa_rasm $(OBJECTS) $(LEXLIB)
	#strip xa_rasm

xa_rasm.lex.o: xa_rasm.lex.c xa_rasm.tab.h xa_main.h
	$(CC) $(CFLAGS) -c xa_rasm.lex.c

xa_rasm.tab.o: xa_rasm.tab.c xa_rasm.tab.h xa_main.h
	$(CC) $(CFLAGS) -c xa_rasm.tab.c

xa_main.o: xa_main.c xa_main.h xa_version.h
	$(CC) $(CFLAGS) -Wall -c xa_main.c

xa_link.o: xa_link.c xa_main.h xa_version.h
	$(CC) $(CFLAGS) -Wall -c xa_link.c

xa_rasm.tab.c xa_rasm.tab.h: xa_rasm.y
	$(YACC) xa_rasm.y
	mv y.tab.c xa_rasm.tab.c
	mv y.tab.h xa_rasm.tab.h

xa_rasm.lex.c: xa_rasm.l
	$(LEX) xa_rasm.l
	mv lex.yy.c xa_rasm.lex.c

all: xa_rasm

clean:
	rm -f *.tab.c *.tab.h *.lex.c *.o *.bak y.output *.hex *.lst *.obj
	rm -f xa_rasm xa_link core *~

=== as/z80/Makefile ===
PRJDIR = ../..

include $(PRJDIR)/Makefile.common

OBJDIR	= obj/$(EXT)

SDC	= .

SLIBSRC	= NewAlloc.c

SRC	= asdata.c asexpr.c aslex.c aslist.c asmain.c asout.c \
	  assubr.c assym.c z80adr.c z80ext.c z80mch.c z80pst.c

OBJS	= $(SRC:%.c=$(OBJDIR)/%.o)
SLIBOBJS	= $(SLIBSRC:%.c=$(OBJDIR)/%.o) 

BINS	= $(BUILDDIR)/as$(EXT)$(EXEEXT)

CFLAGS	+= $(CPPFLAGS) $(OPTS) -I. -DINDEXLIB -DMLH_MAP -DUNIX -DSDK
CFLAGS	+= -funsigned-char
CFLAGS	+= -I$(SLIB) 

LDFLAGS += -lm $(EXTRALIBS)

all:	dep $(BINS)

dep: Makefile.dep

Makefile.dep: $(SRC) *.h
	$(CPP) $(CPPFLAGS) $(M_OR_MM) $(SRC) > Makefile.dep

include Makefile.dep

# We need a '.stamp'-file in $(OBJDIR), because the time stamp
# of $(OBJDIR) itself is always updated, when a file in $(OBJDIR)
# is updated. A rule like
#	$(OBJDIR)/anyfile: $(OBJDIR)
# will always force a remake (at least on Linux ext2).

$(OBJDIR)/.stamp:
	mkdir -p $(OBJDIR)
	touch $(OBJDIR)/.stamp

$(BINS): $(OBJS) $(SLIBOBJS)
	$(CC) -o $(BINS) $(OBJS) $(SLIBOBJS) $(LDFLAGS)


$(OBJDIR)/%.o:	%.c $(OBJDIR)/.stamp
	$(CC) -c $(CFLAGS) -o $@ $<

$(OBJDIR)/%.o:	$(SLIB)/%.c $(OBJDIR)/.stamp
	$(CC) -c $(CFLAGS) -o $@ $<

_as-z80:
	$(MAKE) EXT=-z80$(E)

_as-gbz80:
	$(MAKE) EXT=-gbz80$(E) OPTS=-DGAMEBOY

include clean.mk

=== link/z80/Makefile ===
PRJDIR = ../..

include $(PRJDIR)/Makefile.common

OBJDIR	= obj/$(EXT)

SLIBSRC	= NewAlloc.c

SRC	= lkarea.c lkdata.c lkeval.c lkhead.c lkihx.c lklex.c \
	  lklibr.c lklist.c lkmain.c lkrloc.c lks19.c lksym.c \
	  lkgb.c lkgg.c

OBJS	= $(SRC:%.c=$(OBJDIR)/%.o) 
SLIBOBJS	= $(SLIBSRC:%.c=$(OBJDIR)/%.o) 

BINS	= $(BUILDDIR)link$(EXT)$(EXEEXT)

CFLAGS	+= $(CPPFLAGS) $(OPTS) -DINDEXLIB -DMLH_MAP -DUNIX -DSDK
CFLAGS	+= -funsigned-char -DUNIX
CFLAGS	+= -I$(PRJDIR)/as/$(PORT) -I$(SLIB) 

LDFLAGS += -lm $(EXTRALIBS)

all:	$(BINS)

$(BINS): $(OBJDIR) $(OBJS) $(SLIBOBJS)
	$(CC) -g -o $(BINS) $(OBJS) $(SLIBOBJS) $(LDFLAGS)

$(OBJDIR):
	mkdir -p $(OBJDIR)

$(OBJDIR)/%.o:	%.c
	$(CC) -c $(CFLAGS) -o $@ $<

$(OBJDIR)/%.o:	$(SLIB)/%.c
	$(CC) -c $(CFLAGS) -o $@ $<

_link-z80:
	$(MAKE) EXT=-z80$(E) PORT=z80

_link-gbz80:
	$(MAKE) EXT=-gbz80$(E) OPTS=-DGAMEBOY PORT=z80

include clean.mk

=== sim/ucsim/Makefile ===
#
# uCsim Makefile
#
# (c) Drotos Daniel, Talker Bt. 1997,99
#

STARTYEAR	= 1997

SHELL		= /bin/sh

PRJDIR		= .
include packages.mk
#PKGS		= cmd.src sim.src gui.src s51.src avr.src z80.src doc

srcdir          = .


# Compiling entire program or any subproject
# ------------------------------------------
all: checkconf
	$(MAKE) -f main.mk all
	@for pkg in $(PKGS); do\
	  cd $$pkg && $(MAKE) $$pkg ; cd ..;\
	done
	$(MAKE) -f main.mk main_app

libs: main.mk
	$(MAKE) -f main.mk libs


# Compiling and installing everything and runing test
# ---------------------------------------------------
.PHONY: install INSTALL Install
install:
	$(MAKE) -f main.mk install
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg install ;\
	done


# Deleting all the installed files
# --------------------------------
uninstall:
	$(MAKE) -f main.mk uninstall
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg uninstall ;\
	done


# Deleting all files created by building the program
# --------------------------------------------------
clean:
	$(MAKE) -f clean.mk clean EXEEXT=$(EXEEXT)
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk clean EXEEXT=$(EXEEXT) ;\
	done


# Deleting all files created by configuring or building the program
# -----------------------------------------------------------------
distclean: clean
	$(MAKE) -f clean.mk distclean
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk distclean ;\
	done
	rm -rf doc/*~ doc/*.bak


# Like clean but some files may still exist
# -----------------------------------------
mostlyclean: clean
	$(MAKE) -f clean.mk mostlyclean
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk mostlyclean ;\
	done


# Deleting everything that can reconstructed by this Makefile. It deletes
# everything deleted by distclean plus files created by bison, stc.
# -----------------------------------------------------------------------
realclean: distclean
	$(MAKE) -f clean.mk realclean
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg -f clean.mk realclean ;\
	done


# Creating distribution
# ---------------------
dist: distclean
	@if [ -f devel ]; then\
	  rm -f devel; mkdist; touch devel;\
	else\
	  mkdist;\
	fi


# Performing self-test
# --------------------
check:
	$(MAKE) -f main.mk check
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg check ;\
	done

test:
	$(MAKE) -f main.mk test
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg test ;\
	done


# Performing installation test
# ----------------------------
installcheck:


# Creating dependencies
# ---------------------
dep:
	$(MAKE) -f main.mk dep
	@for pkg in $(PKGS); do\
	  $(MAKE) -C $$pkg dep ;\
	done


# My rules
# --------
putcopyright:
	'put(c)' -s $(STARTYEAR) *.cc *.h *.y *.l

start:
	date '+%Y.%m.%d-%H:%M' >.start

newer: distclean
	@if [ -f .start ]; then \
	  tar cvf - \
	    `find . -newer .start -type f -print` |\
	  gzip -9c >ucsim-newer-`cat .start`_`date '+%Y.%m.%d-%H:%M'`_`hostname`.tgz; \
	else \
	  echo ".start file not found.\n"; \
	  exit 1; \
	fi

print-newer:
	@if [ -f .start ]; then \
	  find . -newer .start -type f -print ;\
	else \
	  echo ".start file not found.\n" ;\
	  exit 1 ;\
	fi

new_files:
	diff -rNu $$HOME/clean-source/sdcc/sim/ucsim .|\
	grep '^diff' | grep -v CVS | awk '{print $$4}'

lines:
	@find . \( -name '*.[ch]' -o -name '*.cc' -o -name '*.hh' \) \
	-exec cat {} \; | clines


# Remaking configuration
# ----------------------
configure: configure.in
	@$(PRJDIR)/mkecho $(PRJDIR) "RE-CREATING CONFIGURE"
	autoconf configure.in >configure
	chmod 755 configure

config.status: configure
	@$(PRJDIR)/mkecho $(PRJDIR) "RE-CHECKING CONFIGURATION (re-creating config.status from configure)"
	@if [ -x ./config.status ]; then \
	  ./config.status -recheck;\
	else\
	  if [ -x ./conf ]; then\
	    ./conf;\
	  else\
	    ./configure;\
	  fi\
	fi

makefiles: config.status
	@$(PRJDIR)/mkecho $(PRJDIR) "RE-MAKING MAKEFILES"
	$(SHELL) ./config.status

main.mk: $(srcdir)/main_in.mk config.status
	@$(PRJDIR)/mkecho $(PRJDIR) "RE-MAKING MAIN.MK"
	$(SHELL) ./config.status

freshconf: echo_freshconf configure main.mk ddconfig.h

ddconfig.h: ddconfig_in.h config.status
	$(SHELL) ./config.status

echo_freshconf:
	@$(PRJDIR)/mkecho $(PRJDIR) "FRESHCONF"

checkconf:
	@$(PRJDIR)/mkecho $(PRJDIR) "CHECKCONF"
	@if [ -f devel ]; then $(MAKE) freshconf; fi

# End of Makefile

=== src/pic/Makefile ===
# Make all in this directory
PORT	= pic

include ../port.mk

=== src/regression/Makefile ===
# Regression testing Makefile for Pic Port of SDCC
#
# note that this regression suite was started before
# the one in sdcc/regression. The regression suite in
# sdcc/regression is better suited for testing mature
# ports.
#
# GPL'd
#
# T. Scott Dattalo scott@dattalo.com
#
# This makefile provides a means by which the output
# of the SDCC Compiler can be tested. This version
# is unique to the PIC (as in Microchip PIC) port.
# As such it requires the following software:
#
#  gpasm version 0.11.1 (or greater)
#  gpsim version 0.20.7 (or greater)
#
# Usage:
#
# make
#  - without any options the whole regression test is
#    performed. The results are placed into a log file
#    (defined by $LOGFILE).
#
# make asm
#  - Creates .asm files by compiling the .c files
#
# make cod
#  - Creates .cod files by assembling the .asm files
#    (.cod files are symbolic files compatible with
#    MPASM, Microchip's assembler)
#
# make stc
#  - Creates .stc files which are script files for
#    gpsim.
#
# make clean
#  - removes all of the intermediate files created
#
# make cleancod
# make cleanasm
# make cleanstc
# make cleano
#  - removes either the .stc, .asm, .cod or .o files


CC = ../../bin/sdcc
LINKER = gplink
TARGETPIC = 16f873
TARGETPIC2 = 16f877
CFLAGS = -mpic14 -c -pp$(TARGETPIC)

.SUFFIXES: .asm .c .cod .stc

# Results of the test are placed here:
LOGFILE = test.log

# Script file for creating gpsim scripts
CREATESTC = create_stc

# Script file for invoking gpsim
SIMULATE = simulate

# List the C files to be test here:
SRC = b.c \
	add.c \
	add2.c \
	add3.c \
	and1.c \
	and2.c \
	bool1.c \
	bool2.c \
	bool3.c \
	call1.c \
	compare.c \
	compare2.c \
	compare3.c \
	compare4.c \
	compare5.c \
	compare6.c \
	for.c \
	nestfor.c \
	or1.c \
	rotate1.c \
	rotate2.c \
	rotate3.c \
	rotate4.c \
	rotate5.c \
	sub.c \
	sub2.c \
	switch1.c \
	while.c \
	xor.c \
	ptrfunc.c

#	struct1.c \
#	mul1.c \

COD := $(patsubst %.c, %.cod, $(SRC))
ASM := $(patsubst %.c, %.asm, $(SRC))
O := $(patsubst %.c, %.o, $(SRC))
STC := $(patsubst %.c, %.stc, $(SRC))
HEX := $(patsubst %.c, %.hex, $(SRC))
LST := $(patsubst %.c, %.lst, $(SRC))
MAP := $(patsubst %.c, %.map, $(SRC))

all:	test


# The asm files are generated by sdcc
.c.o:
	$(CC) $(CFLAGS)  $*.c

# The .cod files are generated by gpasm
# these get loaded by gpsim.
.o.cod:
	$(LINKER) --map -c -s $(TARGETPIC2).lkr -o $*.o $*.o

#	gpasm $*.asm

#	gpasm -c -I $(HEADER) $*.asm


# The .stc files are script files for gpsim
.cod.stc:
	./$(CREATESTC) $*.cod $*.stc
	./$(SIMULATE) $*.stc $(LOGFILE)

# this will also make .stc files
#%.stc : %.cod
#	./create_stc $^ $@

# now for the dependencies

cod : $(COD)

o : $(O)

asm : $(ASM)

stc : $(STC)
	echo $(STC)

test:	$(STC)
	echo "Done - Results are in $(LOGFILE)"

cleancod:
	files="$(COD)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleano:
	files="$(O)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanasm:
	files="$(ASM)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanstc:
	files="$(STC)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanhex:
	files="$(HEX)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanlst:
	files="$(LST)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

clean: cleancod cleanasm cleanstc cleano cleanhex cleanlst
	if [ -f "$(LOGFILE)" ]; then rm $(LOGFILE); fi

=== support/librarian/Makefile ===
PRJDIR          = ../..

include $(PRJDIR)/Makefile.common

CFLAGS          += -Wall

OBJECTS 	= sdcclib.o

SOURCES		= $(patsubst %.o,%.c,$(OBJECTS))

TARGET		= $(PRJDIR)/bin/sdcclib$(EXEEXT)

all: $(TARGET)

install: all installdirs
	$(INSTALL) $(TARGET) `echo $(DESTDIR)$(bindir)/sdcclib$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/sdcclib$(EXEEXT)|sed '$(transform)'`

# Deleting all the installed files
# --------------------------------
uninstall:
	rm -f $(DESTDIR)$(bindir)/sdcclib$(EXEEXT)

# Performing self-test
# --------------------
check:


# Performing installation test
# ----------------------------
installcheck:


# Creating installation directories
# ---------------------------------
installdirs:
	$(INSTALL) -d $(DESTDIR)$(bindir)


# Creating dependencies
# ---------------------
dep:

$(TARGET): $(OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(OBJECTS)

.c.o:
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@


checkconf:

include clean.mk

=== support/makebin/Makefile ===
PRJDIR = ../..

SOURCES = makebin.c
BIN = $(PRJDIR)/bin/makebin$(EXEEXT)

include $(PRJDIR)/Makefile.common

all: $(BIN)

$(BIN): $(OBJ)
	$(CC) $(LDFLAGS) -o $(BIN) $(OBJ)

install: all
	mkdir -p $(DESTDIR)$(bindir)
	$(INSTALL) $(BIN) `echo $(DESTDIR)$(bindir)/makebin$(EXEEXT)|sed '$(transform)'`
	$(STRIP) `echo $(DESTDIR)$(bindir)/makebin$(EXEEXT)|sed '$(transform)'`

uninstall:
	rm -f $(DESTDIR)$(bindir)/makebin$(EXEEXT)

include clean.mk

## sdcc 2.6.0

=== src/regression/Makefile ===
--- 
+++ 
@@ -45,12 +45,14 @@
 # make cleano
 #  - removes either the .stc, .asm, .cod or .o files
 
+# verboseness
+#Q ?= # be verbose
+Q ?= @ # be quiet
 
-CC = ../../bin/sdcc
+CC = sdcc
 LINKER = gplink
-TARGETPIC = 16f873
-TARGETPIC2 = 16f877
-CFLAGS = -mpic14 -c -pp$(TARGETPIC)
+TARGETPIC = 16f877
+CFLAGS = -Wl,--map -I ../../device/include/pic -mpic14 -pp$(TARGETPIC) -Wl,-q
 
 .SUFFIXES: .asm .c .cod .stc
 
@@ -70,8 +72,8 @@
 	add3.c \
 	and1.c \
 	and2.c \
+	b.c \
 	bool1.c \
-	bool2.c \
 	bool3.c \
 	call1.c \
 	compare.c \
@@ -81,8 +83,11 @@
 	compare5.c \
 	compare6.c \
 	for.c \
+	inline.c \
 	nestfor.c \
 	or1.c \
+	ptrarg.c \
+	ptrfunc.c \
 	rotate1.c \
 	rotate2.c \
 	rotate3.c \
@@ -92,11 +97,22 @@
 	sub2.c \
 	switch1.c \
 	while.c \
-	xor.c \
-	ptrfunc.c
-
+	xor.c
+#	arrays.c \
+#	add4.c \
+#	bank1.c \
+#	compare7.c \
+#	compare8.c \
+#	compare9.c \
+#	compare10.c \
+#	configword.c \
+#	mult1.c \
+#	pointer1.c \
+#	rotate6.c \
+#	rotate7.c \
+#	string1.c \
 #	struct1.c \
-#	mul1.c \
+#	bool2.c \
 
 COD := $(patsubst %.c, %.cod, $(SRC))
 ASM := $(patsubst %.c, %.asm, $(SRC))
@@ -109,24 +125,14 @@
 all:	test
 
 
-# The asm files are generated by sdcc
-.c.o:
-	$(CC) $(CFLAGS)  $*.c
-
-# The .cod files are generated by gpasm
-# these get loaded by gpsim.
-.o.cod:
-	$(LINKER) --map -c -s $(TARGETPIC2).lkr -o $*.o $*.o
-
-#	gpasm $*.asm
-
-#	gpasm -c -I $(HEADER) $*.asm
-
+# The cod files are generated by sdcc
+.c.cod:
+	$(Q)$(CC) $(CFLAGS) $*.c
 
 # The .stc files are script files for gpsim
 .cod.stc:
-	./$(CREATESTC) $*.cod $*.stc
-	./$(SIMULATE) $*.stc $(LOGFILE)
+	$(Q)./$(CREATESTC) $*.cod $*.stc
+	$(Q)./$(SIMULATE) $*.stc $(LOGFILE)
 
 # this will also make .stc files
 #%.stc : %.cod
@@ -144,7 +150,7 @@
 	echo $(STC)
 
 test:	$(STC)
-	echo "Done - Results are in $(LOGFILE)"
+	$(Q)echo "Done - Results are in $(LOGFILE)"
 
 cleancod:
 	files="$(COD)" ; \

=== device/examples/xa51/Makefile ===
CC = sdcc

CFLAGS= -Wa-s --dumpall
MFLAGS= -mxa51
#LFLAGS= --code-loc 0x1000 --xram-loc 0x4000
LFLAGS= --xram-loc 0x4000

all: hello.hex

OBJECTS = hello.rel hwinit.rel dummy.rel

hello.hex: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)
	echo go | sxa hello.hex

clean:
	rm -f core *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map \
		*.xa *.rst *.sym *.lnk *.lib *.bin *.dump* *.log

%.rel: %.c hw.h
	$(CC) -c $(CFLAGS) $(MFLAGS) $<

=== device/lib/pic16/libsdcc/stack/Makefile ===
top_builddir = ../../
top_srcdir   = ../..
srcdir       = .


SUBDIRS = 

include $(top_srcdir)/Makefile.subdir

## sdcc 2.7.0

=== src/regression/Makefile ===
--- 
+++ 
@@ -52,7 +52,12 @@
 CC = sdcc
 LINKER = gplink
 TARGETPIC = 16f877
-CFLAGS = -Wl,--map -I ../../device/include/pic -mpic14 -pp$(TARGETPIC) -Wl,-q
+TARGETPIC = 16f84
+CFLAGS = -mpic14 -p$(TARGETPIC)
+CFLAGS += -Wl,-q
+CFLAGS += -Wl,--map -I ../../device/include/pic
+CFLAGS += -L ../../device/lib/pic/bin
+#CFLAGS += --no-pcode-opt
 
 .SUFFIXES: .asm .c .cod .stc
 
@@ -66,57 +71,59 @@
 SIMULATE = simulate
 
 # List the C files to be test here:
-SRC = b.c \
-	add.c \
-	add2.c \
-	add3.c \
-	and1.c \
-	and2.c \
-	b.c \
-	bool1.c \
-	bool3.c \
-	call1.c \
-	compare.c \
-	compare2.c \
-	compare3.c \
-	compare4.c \
-	compare5.c \
-	compare6.c \
-	for.c \
-	inline.c \
-	nestfor.c \
-	or1.c \
-	ptrarg.c \
-	ptrfunc.c \
-	rotate1.c \
-	rotate2.c \
-	rotate3.c \
-	rotate4.c \
-	rotate5.c \
-	sub.c \
-	sub2.c \
-	switch1.c \
-	while.c \
-	xor.c
-#	arrays.c \
-#	add4.c \
-#	bank1.c \
-#	compare7.c \
-#	compare8.c \
-#	compare9.c \
-#	compare10.c \
-#	configword.c \
-#	mult1.c \
-#	pointer1.c \
-#	rotate6.c \
-#	rotate7.c \
-#	string1.c \
-#	struct1.c \
-#	bool2.c \
+SRC = add.c \
+      add2.c \
+      add3.c \
+      add4.c \
+      and1.c \
+      and2.c \
+      arrays.c \
+      b.c \
+      bank1.c \
+      bool1.c \
+      bool2.c \
+      bool3.c \
+      call1.c \
+      compare.c \
+      compare10.c \
+      compare2.c \
+      compare3.c \
+      compare4.c \
+      compare5.c \
+      compare6.c \
+      compare7.c \
+      compare8.c \
+      compare9.c \
+      configword.c \
+      empty.c \
+      for.c \
+      inline.c \
+      mult1.c \
+      nestfor.c \
+      or1.c \
+      pcodeopt.c \
+      pointer1.c \
+      ptrarg.c \
+      ptrfunc.c \
+      rotate1.c \
+      rotate2.c \
+      rotate3.c \
+      rotate4.c \
+      rotate5.c \
+      rotate6.c \
+      rotate7.c \
+      string1.c \
+      struct1.c \
+      sub.c \
+      sub2.c \
+      switch1.c \
+      while.c \
+      xor.c
 
 COD := $(patsubst %.c, %.cod, $(SRC))
 ASM := $(patsubst %.c, %.asm, $(SRC))
-O := $(patsubst %.c, %.o, $(SRC))
+O   := $(patsubst %.c, %.o,   $(SRC))
+P   := $(patsubst %.c, %.p,   $(SRC))
 STC := $(patsubst %.c, %.stc, $(SRC))
 HEX := $(patsubst %.c, %.hex, $(SRC))
 LST := $(patsubst %.c, %.lst, $(SRC))
@@ -127,12 +134,12 @@
 
 # The cod files are generated by sdcc
 .c.cod:
-	$(Q)$(CC) $(CFLAGS) $*.c
+	$(Q)-$(CC) $(CFLAGS) $*.c
 
 # The .stc files are script files for gpsim
 .cod.stc:
-	$(Q)./$(CREATESTC) $*.cod $*.stc
-	$(Q)./$(SIMULATE) $*.stc $(LOGFILE)
+	$(Q)-./$(CREATESTC) $*.cod $*.stc
+	$(Q)-./$(SIMULATE) $*.stc $(LOGFILE)
 
 # this will also make .stc files
 #%.stc : %.cod
@@ -164,6 +171,12 @@
 	  if [ -f $$f ]; then rm $$f; fi \
 	done ; \
 
+cleanp:
+	files="$(P)" ; \
+	for f in $$files ; do \
+	  if [ -f $$f ]; then rm $$f; fi \
+	done ; \
+
 cleanasm:
 	files="$(ASM)" ; \
 	for f in $$files ; do \
@@ -188,5 +201,11 @@
 	  if [ -f $$f ]; then rm $$f; fi \
 	done ; \
 
-clean: cleancod cleanasm cleanstc cleano cleanhex cleanlst
+cleanmap:
+	files="$(MAP)" ; \
+	for f in $$files ; do \
+	  if [ -f $$f ]; then rm $$f; fi \
+	done ; \
+
+clean: cleancod cleanasm cleanstc cleano cleanp cleanhex cleanlst cleanmap
 	if [ -f "$(LOGFILE)" ]; then rm $(LOGFILE); fi

=== device/examples/ds390/test390/Makefile ===

all : test390.ihx

test390.ihx : test390.c
	sdcc -mds390 test390.c

normal :
	sdcc -mds390 --model-large test390.c

clean:
	rm -f mon.ihx *.lst *.rel *.rst *.sym *.cdb *.map *.ihx *.lnk *.asm

sim:
	./s51 -t DS390F -Sout=test.lst test390.ihx

sim_norm:
	./s51 -t DS390 -Sout=test.lst test390.ihx

## sdcc 2.8.0.dfsg

=== device/examples/ds390/i2c390/Makefile ===
CC = sdcc

MFLAGS = -mds390
LFLAGS = --xram-loc 0x100080 --code-loc 0x10000 -Wl-r

OBJECTS = i2c390.rel ds1621.rel pcf8591.rel

all: i2c390.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk core *.dump*

i2c390.hex: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)
	packihx i2c390.ihx >i2c390.hex
	#tinitalk -c execute i2c390.hex

%.rel: %.c
	$(CC) -c $(MFLAGS) $<

=== device/examples/ds390/ow390/Makefile ===
CC = sdcc

MFLAGS = -mds390
LFLAGS = --xram-loc 0x180080 --code-loc 0x10000 -Wl-r

TARGETS = tstfind.hex temp.hex swtloop.hex swtoper.hex counter.hex \
	tstow.hex thermodl.hex gethumd.hex

OW_OBJECTS = ownetu.rel owsesu.rel owllu.rel owlli.rel owtrnu.rel \
	crcutil.rel tinilnk.rel findtype.rel ds2480ut.rel owfile.rel

SENSOR_OBJECTS = temp10.rel  swt12.rel cnt1d.rel thermo21.rel ad26.rel

TINI_TEST_OBJECTS =

all: ow.lib sensors.lib $(TINI_TEST_OBJECTS) $(TARGETS)

ow.lib: $(OW_OBJECTS)
	rm -f $@; \
	for object in $(OW_OBJECTS) $(TINI_TEST_OBJECTS); do \
		echo $$object >>$@; \
	done;

sensors.lib: $(SENSOR_OBJECTS)
	rm -f $@; \
	for object in $(SENSOR_OBJECTS); do \
		echo $$object >>$@; \
	done;

clean:
	rm -f core *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map \
		*.rst *.sym *.lnk *.lib *.dump*

%.hex: ow.lib sensors.lib $(TINI_TEST_OBJECTS) %.rel
	$(CC) $(MFLAGS) $(LFLAGS) $*.rel $(TINI_TEST_OBJECTS) \
		-L . ow.lib sensors.lib
	packihx $*.ihx >$@
	#tinitalk -c execute $@

%.rel: %.c
	$(CC) -c $(MFLAGS) $<

## sdcc 3.1.0+dfsg

=== src/regression/Makefile ===
--- 
+++ 
@@ -49,17 +49,31 @@
 #Q ?= # be verbose
 Q ?= @ # be quiet
 
-CC = sdcc
+SDCC_SRC=../..
+SDCC_BIN=../..
+
+CC = $(SDCC_BIN)/bin/sdcc
 LINKER = gplink
+USE_PIC16 ?= 0
+ifeq ($(strip $(filter 1 yes,$(USE_PIC16))),)
 TARGETPIC = 16f877
-TARGETPIC = 16f84
+#TARGETPIC = 16f84
 CFLAGS = -mpic14 -p$(TARGETPIC)
+DIR = pic14
+else
+TARGETPIC = 18f452
+CFLAGS	= -mpic16 -p$(TARGETPIC)
+DIR = pic16
+endif
 CFLAGS += -Wl,-q
-CFLAGS += -Wl,--map -I ../../device/include/pic
-CFLAGS += -L ../../device/lib/pic/bin
+CFLAGS += -Wl,--map
+CFLAGS += -I $(SDCC_SRC)/device/include/$(DIR) -I $(SDCC_SRC)/device/non-free/include/$(DIR)
+CFLAGS += -L $(SDCC_BIN)/device/lib/$(DIR)/bin -L $(SDCC_BIN)/device/non-free/lib/$(DIR)/bin
 #CFLAGS += --no-pcode-opt
+#CFLAGS += -V
 
 .SUFFIXES: .asm .c .cod .stc
+.NOTPARALLEL:
 
 # Results of the test are placed here:
 LOGFILE = test.log
@@ -97,6 +111,7 @@
       configword.c \
       empty.c \
       for.c \
+      init0.c \
       inline.c \
       mult1.c \
       nestfor.c \

=== device/lib/z180/Makefile ===
# libc/z80 Makefile


srcdir = .
top_builddir = ../../..

AR_S            = ar -S

LIB_TYPE        = RANLIB

TOPDIR = ../../..

SCC = $(TOPDIR)/bin/sdcc -mz180
SAS = $(TOPDIR)/bin/sdasz80

# override PORTDIR defined by super (parent) makefile
override PORTDIR = ../build/z180

include $(srcdir)/../incl.mk

Z80_FLOAT = $(COMMON_FLOAT)

Z80_INT = $(COMMON_INT)

Z80_LONG = $(COMMON_LONG) \
  _divulong.c \
  _mullong.c

Z80_SDCC = $(COMMON_SDCC) \
  _itoa.c \
  _ltoa.c \
  _startup.c \
  sprintf.c \
  vprintf.c

Z80SOURCES = $(addprefix ../,$(Z80_FLOAT) $(Z80_INT) $(Z80_LONG) $(Z80_SDCC))
Z8OBJECTS = $(patsubst %.c,%.rel,$(Z80_FLOAT) $(Z80_INT) $(Z80_LONG) $(Z80_SDCC))

OBJ = divunsigned.rel divsigned.rel divmixed.rel modunsigned.rel modsigned.rel modmixed.rel mul.rel mulchar.rel \
      putchar.rel shift.rel stubs.rel crt0_rle.rel heap.rel fstubs.rel memmove.rel strlen.rel abs.rel crtcall.rel \
      setjmp.rel

LIB = z180.lib
CC = $(SCC)
AS = $(SAS)
ASFLAGS = -plosgff

CFLAGS = -I$(srcdir)/../../include -I. --std-c99

all: $(PORTDIR)/$(LIB) $(PORTDIR)/crt0.rel

$(PORTDIR)/crt0.rel: crt0.rel
	cp crt0.rel $(PORTDIR)/crt0.rel

$(PORTDIR)/$(LIB): $(OBJ) $(Z8OBJECTS) Makefile
ifeq ($(LIB_TYPE), SDCCLIB)
	rm -f $@; \
	../../../bin/sdcclib -a $@ $(OBJ) $(Z8OBJECTS)
else
  ifeq ($(LIB_TYPE), AR)
	$(AR_S) -cq $@ $(OBJ) $(Z8OBJECTS)
  else
    ifeq ($(LIB_TYPE), RANLIB)
	$(AR_S) -cq $@ $(OBJ) $(Z8OBJECTS)
	$(top_builddir)/bin/sdranlib $@
    else
	rm -f $@; \
	for i in $(basename $(OBJ) $(Z8OBJECTS)); do echo $$i >>$@; done
	cp $(OBJ) $(Z8OBJECTS) $(PORTDIR)
    endif
  endif
endif

%.rel: %.c
	$(CC) $(CFLAGS) -c $<

%.rel: %.s
	@# TODO: sdas should place it\'s output in the current dir
	test $(srcdir) = . || cp $< .
	-$(AS) $(ASFLAGS) $(notdir $<)
	test $(srcdir) = . || rm $(notdir $<)

%.rel: ../%.c
	$(CC) $(CFLAGS) -c $<

clean:
	rm -f *.rel *.sym *.lst *~ $(CLEANSPEC) *.dump* *.asm *.lib

distclean: clean
	rm -f Makefile

=== debian/changelog ===
sdcc (3.1.0+dfsg-1ubuntu1) quantal; urgency=low

  * Remove build-indep from build target. Add it as a requisite of the
    install-indep target. This will keep it from being built on binary-arch
    builds, but still work on full builds. Not ideal, but it will suffice
    so that slow buildd's wont have to install all of lyx and tex just to
    churn out a small binary.

 -- Ben Collins <bcollins@ubuntu.com>  Wed, 13 Jun 2012 23:27:54 -0400

sdcc (3.1.0+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #647036)
  * Switch to dpkg-source 3.0 (quilt) format
  * Remove lk_readnl fix from rules file
  * Bump standards version to 3.9.3
  * Change Conflicts to Breaks in control file
  * Suggest python for sdcc
  * Add arch-dependent-file-in-usr-share to overrides file
  * Add recommended target build arch (Closes: #459877)
  * Fix whatis entry for as2xxxx.1 manpage
  * Add manpage for as2gbmap
  * Add a get-orig-source target to rules file
  * Exclude non-free sources from source package (Closes: #597933)
  * Add +dfsg to source package name
  * Add version mangling to watch file
  * Add Vcs fields
  * Change all references to asranlib to sdranlib
  * Remove patches 01_fix_getline  02_result_type_gptr  03_fix_cmdlex
  * Remove sim/ucsim/libltdl in get-orig-source
  * Remove patch 04_libtool_fix
  * Rename other patches from 05, 06 to 01, 02
  * Add GPL+LE to copyright file
  * Fix sdcc manpage (Closes: #658188)
  * Bump compat to 8
  * Add build dependency on libboost-dev
  * Change texlive dependency to texlive-full. I clould not find minimum set
    of texlive packages needed to compile the package.
  * Remove go.bat from sdcc-doc
  * Add Build-Depends-Indep field (Thanks to Aron Xu)
  * Fix build/install arch/indep (Thanks to Aron Xu)
  * Fix lintian override file
  * Fix cleaning of .asm files, too many were removed

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Mon, 04 Jun 2012 09:29:53 +0000

sdcc (2.9.0+dfsg-1) unstable; urgency=low

  * Remove all pic header and library files (Closes: #597933)
  * Add patch 05_exclude_pic_lib
  * Bump standards version to 3.9.1
  * Switch to dpkg-source 3.0 (quilt) format
  * Remove Conflicts: sdcc (<= 2.3.3+cvs20030131-4)
  * Remove Conflicts: sdcc (<< 2.3.8+cvs20040218-1)
  * Change hypen to minus in ucsim.1
  * Add description to all patches
  * Fixed watch file

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Fri, 17 Dec 2010 07:42:20 +0100

sdcc (2.9.0-5) unstable; urgency=low

  * Add patch 03_fix_cmdlex to fix compilation (Closes: #560520)
  * Add patch 04_libtool_fix to fix CVE-2009-3736 local privilege escalation
    After patching, ltld.c is equal to the ltld.c file in libtool 2.2.6B
    (Closes: #559840)
  * Add README.source file

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sat, 09 Jan 2010 05:47:41 +0100

sdcc (2.9.0-4) unstable; urgency=low

  * Add patch 01_fix_ftbs (Closes: #552867)
  * Bump standards version to 3.8.3, no changes needed
  * Remove bashism from debian scripts (Closes: #535420)
  * Add README.source file
  * Add patch 02_result_type_gptr
  * Add dependency on quilt

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sat, 14 Nov 2009 18:22:59 +0100

sdcc (2.9.0-3) unstable; urgency=low

  * patch from Keith Packard to promote varargs pointers to RESULT_TYPE_GPTR,
    accepted by upstream for 2.9.1

 -- Bdale Garbee <bdale@gag.com>  Sun, 09 Aug 2009 15:00:31 -0600

sdcc (2.9.0-2) unstable; urgency=low

  * Add conflict to sdcc-libraries (<<2.9.0) (Closes: #524864)

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sun, 03 May 2009 22:31:16 +0200

sdcc (2.9.0-1) unstable; urgency=low

  [ Bdale Garbee ]
  * new upstream version, with assemblers re-licensed under GPL version 3 or
    later, allowing the full SDCC package to return to Debian main!
  * update debian/copyright to more accurately reflect the set of copyright
    holders, and in light of the assemblers now being GPL v3 or later.
  * stop building html docs again since latex2html is non-free

  [ Gudjon I. Gudjonsson ]
  * Move manpages to debian/manpages
  * Edit the copyright file
  * Remove references to html doc from sdcc-doc.doc-base
  * Remove XS-Autobuild field
  * Bump standards version to 3.8.1, no changes needed
  * Add fields to install and remove postscript documentation
  * Add some perl scripts to sdcc package
  * Add examples to sdcc-doc
  * Add a lot to the clean target in rules. Will be sent to upstream
  * Add watch file

 -- Bdale Garbee <bdale@gag.com>  Thu, 09 Apr 2009 14:14:27 -0700

sdcc-nf (2.8.0-1) unstable; urgency=low

  [ Bdale Garbee ]
  * new upstream version
  * add Bdale as a co-maintainer

  [ Gudjon I. Gudjonsson ]
  * Renamed the packages. A DFSG version of the packages have been
    made and put into main, this non-free version has therefore the
    name extension -nf on all packages.
  * This version conflicts and provides the corresponding DFSG version.
  * Bumped the Debian policy standard version to 3.7.3. No changes needed.
  * Added a "XS-Autobuild: yes" field to the control file.
  * Removed the p89c66x.h file since it is included in upstream now.
  * Fixed some lintian warnings from doc-base file.
  * A new upstream version. (Closes: #474090)

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Thu, 24 Apr 2008 13:52:02 +0000

sdcc (2.7.0-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New Upstream Version.
  * New Maintainer. Closes: #393289
  * Updated Build-Depends:
    + Added: autotools-dev to get the newest config.sub and config.guess
    + Added: autoconf, automake, libtool
    + Replaced lyx-qt by lyx
  * Cleaned debian/rules a bit
  * Use config.sub and config.guess from autotools-dev

  [ Gudjon I. Gudjonsson ]
  * New upstream version (Closes: #440380)
  * Replaced lyx-xforms (Closes: #444558)
  * Upgraded install targets for the new version.
  * Added the p89c66x.h header file. Will be included in 2.7.1
  * Added the copyright clause for ASxxxx into copyright.


=== debian/control ===
Source: sdcc
Section: electronics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>=8), autoconf, autotools-dev, libtool, flex, bison, 
 libncurses5-dev, gputils, libboost-dev
Build-Depends-Indep: lyx, texlive-full, ghostscript,
Standards-Version: 3.9.3
Homepage: http://sdcc.sourceforge.net
Vcs-Git: git://anonscm.debian.org/collab-maint/sdcc.git
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/sdcc.git

Package: sdcc
Architecture: any
Depends: sdcc-libraries (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: sdcc-doc
Suggests: sdcc-ucsim, python
Breaks: sdcc-libraries (<< 2.9.0)
Description: Small Device C Compiler
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package includes the compiler, assemblers and linkers.

Package: sdcc-libraries
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gputils
Description: Small Device C Compiler (libraries)
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package contains the core library for SDCC.

Package: sdcc-ucsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: sdcc
Replaces: sdcc-ucsim-snapshot
Description: Micro-controller simulator for SDCC
 uCsim is a microcontroller simulator. It is extensible to support
 different microcontroller families. It currently supports Intel 
 MCS51 family, HC08 and Z80 microcontrollers.

Package: sdcc-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: sdcc
Description: Small Device C Compiler (documentation)
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package provides the documentation and examples for the
 SDCC compiler.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

export HOME=$(CURDIR)/build

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -O0
	export STRIP=true
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

clean:
	dh_testdir
	dh_testroot
	# Clean up files that Makefile should have cleaned
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f device/lib/pic14/config.h
	rm -f device/lib/pic14/config.log
	rm -f device/lib/pic14/stamp-h1
	rm -f device/lib/r2k/*.asm
	rm -f device/lib/z180/*.asm
	rm -f sim/ucsim/cmd.src/cmdlex.cc
	rm -f sim/ucsim/cmd.src/cmdpars.cc
	rm -f src/pic14/Makefile.dep
	rm -f src/pic14/peeph.rul
	rm -rf $(CURDIR)/build
	rm -f custom.h
	rm -f sim/ucsim/custom.h
	rm -f support/regression/ports/host/spec.mk
	rm -f support/cpp/configargs.h,.log
	rm -f support/cpp/config.log
	rm -f support/cpp/config.status
	rm -f sim/ucsim/config.guess
	rm -f sim/ucsim/config.sub
	rm -f sim/ucsim/config.log
	rm -f config.log
	rm -f device/lib/small-stack-auto/Makefile
	rm -f as/link/asxxxx_config.h
	rm -f support/cpp/configargs.h
	rm -f ports.all ports.build
	rm -f confdefs.h
	find -type f -name '*.o' -exec rm -f {} \;
	find -type f -name '.stamp' -exec rm -f {} \;
	find . -name '*.rel' -exec rm -f {} \;
	find . -name '*.sym' -exec rm -f {} \;
	find . -name '*.lst' -exec rm -f {} \;
	find . -name '*.a' -exec rm -f {} \;
	find . -name config.status -exec rm -f {} \;
	find . -name Makefile -exec rm -f {} \;
	rm -f sim/ucsim/cmd.src/cmdpars.hh
	# Clean up the Debian specific files
	rm -f config.status doc/sdccman.ps
	rm -f *-stamp
	rm -f install-indep install-arch
	dh_clean

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p $(CURDIR)/build
	cp /usr/share/misc/config.sub sim/ucsim/config.sub
	cp /usr/share/misc/config.guess sim/ucsim/config.guess
	./configure \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr
	touch $@

build: build-arch
build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 
	dh_testdir
	$(MAKE)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir
	cd doc && lyx -e ps sdccman.lyx
	touch $@

install: install-arch install-indep
install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
	install -o root -g root -m 644 doc/sdccman.ps debian/tmp/usr/share/doc/sdcc-doc
	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile
	#Remove extra license file
	rm -f $(CURDIR)/debian/tmp/usr/share/sdcc/lib/src/pic16/COPYING
	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`

	dh_install -i --sourcedir=debian/tmp

	# Install examples
	cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
	rm -f $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc/examples/mcs51/simple*/go*
	touch $@

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
	# Add some scripts
	mkdir -p debian/tmp/usr/share/sdcc/scripts
	install -o root -g root -m 755  support/scripts/inc2h-pic16.pl debian/tmp/usr/share/sdcc/scripts
	install -o root -g root -m 755  support/scripts/inc2h.pl       debian/tmp/usr/share/sdcc/scripts
	install -o root -g root -m 755  support/scripts/keil2sdcc.pl   debian/tmp/usr/share/sdcc/scripts

	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`

	dh_install -a --sourcedir=debian/tmp

	touch $@

# Must not depend on anything. This is to be called by binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installman
	#dh_installexamples -psdcc-doc device/examples/* -X\.bat  
	dh_installemacsen
	dh_link
	dh_lintian
	dh_strip -Xusr/share/sdcc/lib/
	dh_compress 
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-independent files here.
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture-dependent files here.
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

get-orig-source:
	VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-+~]+).*,\1,p'); \
	uscan --force-download --rename --download-version=$$VER --destdir=. && (\
	tar -xj --exclude device/non-free --exclude sim/ucsim/libltdl -f sdcc_$$VER.orig.tar.bz2 ; \
	mv sdcc sdcc-$$VER+dfsg;\
	tar -czf sdcc_$$VER+dfsg.orig.tar.gz sdcc-$$VER+dfsg; \
	rm -rf sdcc-$$VER+dfsg ;\
	rm -f sdcc_$$VER.orig.tar.bz2);

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-arch install-indep

## sdcc 3.3.0%2Bdfsg

=== device/examples/ds390/readmac/Makefile ===
CC = sdcc

MFLAGS = -mds390
LFLAGS = --xram-loc 0x180080 --code-loc 0x10000 -Wl-r

OBJECTS = readmac.rel ow.rel crcutil.rel

all: readmac.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk core *.dump*

readmac.hex: readmac.ihx
	packihx readmac.ihx >readmac.hex

readmac.ihx: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)

%.rel: %.c
	$(CC) -c $(MFLAGS) $<
